var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var get_dict_action_exports = {};
__export(get_dict_action_exports, {
  default: () => getDictAction
});
module.exports = __toCommonJS(get_dict_action_exports);
async function getDictAction(ctx, next) {
  ctx.withoutDataWrapping = true;
  let collectionNames = await ctx.db.getRepository("collections").find();
  collectionNames = collectionNames.map((item) => item.get("name"));
  const collections = [];
  for (const [name, collection] of ctx.db.collections) {
    const columns = [];
    for (const key in collection.model.rawAttributes) {
      if (Object.prototype.hasOwnProperty.call(collection.model.rawAttributes, key)) {
        const attribute = collection.model.rawAttributes[key];
        columns.push({
          realName: attribute.field,
          name: key
        });
      }
    }
    const item = {
      name,
      tableName: collection.model.tableName,
      title: collection.options.title,
      namespace: collection.options.namespace,
      duplicator: collection.options.duplicator,
      schema: collection.options.schema || process.env.DB_SCHEMA
      // columns,
    };
    if (!item.namespace && collectionNames.includes(name)) {
      item.namespace = "collection-manager";
      if (!item.duplicator) {
        item.duplicator = "optional";
      }
    }
    collections.push(item);
  }
  ctx.body = collections;
  await next();
}
