var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var restore_action_exports = {};
__export(restore_action_exports, {
  getPackageContent: () => getPackageContent,
  restoreAction: () => restoreAction
});
module.exports = __toCommonJS(restore_action_exports);
var import_restorer = require("../restorer");
var os = __toESM(require("os"));
var import_path = __toESM(require("path"));
var import_get_app = require("./get-app");
async function restoreAction(ctx, next) {
  const { restoreKey, selectedOptionalGroups, selectedUserCollections } = ctx.request.body;
  const appName = ctx.request.body.app;
  const tmpDir = os.tmpdir();
  const filePath = import_path.default.resolve(tmpDir, restoreKey);
  const app = await (0, import_get_app.getApp)(ctx, appName);
  const restorer = new import_restorer.Restorer(app, {
    backUpFilePath: filePath
  });
  await restorer.restore({
    selectedOptionalGroupNames: selectedOptionalGroups,
    selectedUserCollections
  });
  await next();
}
const getPackageContent = async (ctx, next) => {
  const file = ctx.file;
  const fileName = file.filename;
  const restorer = new import_restorer.Restorer(ctx.app, {
    backUpFilePath: file.path
  });
  const restoreMeta = await restorer.parseBackupFile();
  ctx.body = {
    key: fileName,
    meta: restoreMeta
  };
  await next();
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getPackageContent,
  restoreAction
});
