/// <reference types="node" />
import { Application } from '@nocobase/server';
import EventEmitter from 'events';
export type AppMigratorOptions = {
    workDir?: string;
};
declare abstract class AppMigrator extends EventEmitter {
    protected workDir: string;
    app: Application;
    abstract direction: 'restore' | 'dump';
    emitAsync: (event: string | symbol, ...args: any[]) => Promise<boolean>;
    constructor(app: any, options?: AppMigratorOptions);
    tmpDir(): string;
    getPluginCollections(plugins: string | string[]): string[];
    getAppPlugins(): Promise<any[]>;
    getAppPluginCollectionGroups(): Promise<import("@nocobase/database").CollectionGroup[]>;
    getCustomCollections(): Promise<any>;
    rmDir(dir: string): Promise<void>;
    clearWorkDir(): Promise<void>;
    findThroughCollections(collections: string[]): any[];
    findSequenceFields(collections: string[]): any[];
}
export { AppMigrator };
