var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var app_migrator_exports = {};
__export(app_migrator_exports, {
  AppMigrator: () => AppMigrator
});
module.exports = __toCommonJS(app_migrator_exports);
var import_utils = require("@nocobase/utils");
var import_crypto = __toESM(require("crypto"));
var import_events = __toESM(require("events"));
var import_promises = __toESM(require("fs/promises"));
var import_lodash = __toESM(require("lodash"));
var os = __toESM(require("os"));
var import_path = __toESM(require("path"));
var import_collection_group_manager = require("./collection-group-manager");
class AppMigrator extends import_events.default {
  workDir;
  app;
  constructor(app, options) {
    super();
    this.app = app;
    this.workDir = (options == null ? void 0 : options.workDir) || this.tmpDir();
  }
  tmpDir() {
    return import_path.default.resolve(os.tmpdir(), `nocobase-${import_crypto.default.randomUUID()}`);
  }
  getPluginCollections(plugins) {
    return import_lodash.default.castArray(plugins).map((pluginName) => {
      return this.app.db.importedFrom.get(pluginName) || [];
    }).flat();
  }
  async getAppPlugins() {
    const plugins = await this.app.db.getCollection("applicationPlugins").repository.find();
    return import_lodash.default.uniq(["core", ...this.app.pm.getAliases(), ...plugins.map((plugin) => plugin.get("name"))]);
  }
  async getAppPluginCollectionGroups() {
    const plugins = await this.getAppPlugins();
    return import_collection_group_manager.CollectionGroupManager.collectionGroups.filter(
      (collectionGroup) => plugins.includes(collectionGroup.namespace)
    );
  }
  async getCustomCollections() {
    const collections = await this.app.db.getCollection("collections").repository.find();
    return collections.filter((collection) => !collection.get("isThrough")).map((collection) => collection.get("name"));
  }
  async rmDir(dir) {
    await import_promises.default.rm(dir, { recursive: true, force: true });
  }
  async clearWorkDir() {
    await this.rmDir(this.workDir);
  }
  findThroughCollections(collections) {
    return [
      ...new Set(
        collections.map((collectionName) => this.app.db.getCollection(collectionName)).map(
          (collection) => [...collection.fields.values()].filter((field) => field.through).map((field) => field.through)
        ).flat()
      )
    ];
  }
  findSequenceFields(collections) {
    return [
      ...new Set(
        collections.map((collectionName) => this.app.db.getCollection(collectionName)).map((collection) => [...collection.fields.values()].filter((field) => field.type === "sequence")).flat()
      )
    ];
  }
}
(0, import_utils.applyMixins)(AppMigrator, [import_utils.AsyncEmitter]);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AppMigrator
});
