var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var dump_command_exports = {};
__export(dump_command_exports, {
  default: () => addDumpCommand
});
module.exports = __toCommonJS(dump_command_exports);
var import_inquirer = __toESM(require("inquirer"));
var import_server = require("@nocobase/server");
var import_dumper = require("../dumper");
var import_inquire_question_builder = __toESM(require("./inquire-question-builder"));
function addDumpCommand(app) {
  app.command("dump").option("-a, --app <appName>", "sub app name if you dump sub app in multiple apps").action(async (options) => {
    let dumpApp = app;
    if (options.app) {
      const subApp = await import_server.AppSupervisor.getInstance().getApp(options.app);
      if (!subApp) {
        app.log.error(`app ${options.app} not found`);
        await app.stop();
        return;
      }
      dumpApp = subApp;
    }
    await dumpCommandAction(dumpApp);
  });
}
async function dumpCommandAction(app) {
  const dumper = new import_dumper.Dumper(app);
  const { requiredGroups, optionalGroups, userCollections } = await dumper.dumpableCollections();
  const questions = import_inquire_question_builder.default.buildInquirerQuestions({
    requiredGroups,
    optionalGroups,
    optionalCollections: userCollections,
    direction: "dump"
  });
  const results = await import_inquirer.default.prompt(questions);
  const { filePath } = await dumper.dump({
    selectedOptionalGroupNames: results.collectionGroups,
    selectedUserCollections: results.userCollections
  });
  app.log.info(`dumped to ${filePath}`);
  await app.stop();
}
