import { CollectionGroup } from '@nocobase/database';
export default class InquireQuestionBuilder {
    static buildInquirerQuestions(options: {
        requiredGroups: CollectionGroup[];
        optionalGroups: CollectionGroup[];
        optionalCollections: {
            name: string;
            title: string;
        }[];
        direction: 'dump' | 'restore';
    }): {
        type: string;
        name: string;
        message: string;
        loop: boolean;
        pageSize: number;
        choices: any[];
    }[];
    static buildInquirerPluginQuestion(requiredGroups: any, optionalGroups: any, direction: 'dump' | 'restore'): {
        type: string;
        name: string;
        message: string;
        loop: boolean;
        pageSize: number;
        choices: any[];
    };
    static buildInquirerCollectionQuestion(collections: {
        name: string;
        title: string;
    }[], direction: 'dump' | 'restore'): {
        type: string;
        name: string;
        message: string;
        loop: boolean;
        pageSize: number;
        choices: {
            name: string;
            value: string;
            checked: boolean;
        }[];
    };
}
