var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var inquire_question_builder_exports = {};
__export(inquire_question_builder_exports, {
  default: () => InquireQuestionBuilder
});
module.exports = __toCommonJS(inquire_question_builder_exports);
var import_inquirer = __toESM(require("inquirer"));
class InquireQuestionBuilder {
  static buildInquirerQuestions(options) {
    const { requiredGroups, optionalGroups, optionalCollections, direction } = options;
    const questions = [this.buildInquirerPluginQuestion(requiredGroups, optionalGroups, direction)];
    if (optionalCollections.length > 0) {
      questions.push(this.buildInquirerCollectionQuestion(optionalCollections, direction));
    }
    return questions;
  }
  static buildInquirerPluginQuestion(requiredGroups, optionalGroups, direction) {
    return {
      type: "checkbox",
      name: "collectionGroups",
      message: `Select the plugin collections to be ${direction === "dump" ? "dumped" : "restored"}`,
      loop: false,
      pageSize: 20,
      choices: [
        new import_inquirer.default.Separator("== Required =="),
        ...requiredGroups.map((collectionGroup) => ({
          name: `${collectionGroup.function} (${collectionGroup.namespace})`,
          value: `${collectionGroup.namespace}.${collectionGroup.function}`,
          checked: true,
          disabled: true
        })),
        new import_inquirer.default.Separator("== Optional =="),
        ...optionalGroups.map((collectionGroup) => ({
          name: `${collectionGroup.function} (${collectionGroup.namespace})`,
          value: `${collectionGroup.namespace}.${collectionGroup.function}`,
          checked: direction === "dump"
        }))
      ]
    };
  }
  static buildInquirerCollectionQuestion(collections, direction) {
    return {
      type: "checkbox",
      name: "userCollections",
      message: `Select the collection records to be ${direction === "dump" ? "dumped" : "restored"}`,
      loop: false,
      pageSize: 30,
      choices: collections.map((collection) => {
        return {
          name: collection.title,
          value: collection.name,
          checked: direction === "dump"
        };
      })
    };
  }
}
