var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var restore_command_exports = {};
__export(restore_command_exports, {
  default: () => addRestoreCommand
});
module.exports = __toCommonJS(restore_command_exports);
var import_server = require("@nocobase/server");
var import_restorer = require("../restorer");
var import_inquirer = __toESM(require("inquirer"));
var import_inquire_question_builder = __toESM(require("./inquire-question-builder"));
function addRestoreCommand(app) {
  app.command("restore").argument("<string>", "restore file path").option("-a, --app <appName>", "sub app name if you want to restore into a sub app").option("-f, --force", "force restore without warning").action(async (restoreFilePath, options) => {
    let importApp = app;
    if (options.app) {
      if (!await app.db.getCollection("applications").repository.findOne({
        filter: { name: options.app }
      })) {
        await app.db.getCollection("applications").repository.create({
          values: {
            name: options.app
          }
        });
      }
      const subApp = await import_server.AppSupervisor.getInstance().getApp(options.app);
      if (!subApp) {
        app.log.error(`app ${options.app} not found`);
        await app.stop();
        return;
      }
      importApp = subApp;
    }
    if (!options.force && !await restoreWarning()) {
      return;
    }
    await restoreActionCommand(importApp, restoreFilePath);
  });
}
async function restoreWarning() {
  const results = await import_inquirer.default.prompt([
    {
      type: "confirm",
      name: "confirm",
      message: "Danger !!! This action will overwrite your current data, please make sure you have a backup\u2757\uFE0F\u2757\uFE0F",
      default: false
    }
  ]);
  return results.confirm;
}
async function restoreActionCommand(app, restoreFilePath) {
  const restorer = new import_restorer.Restorer(app, {
    backUpFilePath: restoreFilePath
  });
  const restoreMeta = await restorer.parseBackupFile();
  const { requiredGroups, selectedOptionalGroups, selectedUserCollections } = restoreMeta;
  const questions = import_inquire_question_builder.default.buildInquirerQuestions({
    requiredGroups,
    optionalGroups: selectedOptionalGroups,
    optionalCollections: await Promise.all(
      selectedUserCollections.map(async (name) => {
        return { name, title: await restorer.getImportCollectionTitle(name) };
      })
    ),
    direction: "restore"
  });
  const results = await import_inquirer.default.prompt(questions);
  await restorer.restore({
    selectedOptionalGroupNames: results.collectionGroups,
    selectedUserCollections: results.userCollections
  });
  await app.stop();
}
