var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var field_value_writer_exports = {};
__export(field_value_writer_exports, {
  FieldValueWriter: () => FieldValueWriter
});
module.exports = __toCommonJS(field_value_writer_exports);
var import_database = require("@nocobase/database");
var import_lodash = __toESM(require("lodash"));
const getMapFieldWriter = (field) => {
  return (val) => {
    const mockObj = {
      setDataValue: (name, newVal) => {
        val = newVal;
      }
    };
    field.options.set.call(mockObj, val);
    return val;
  };
};
class FieldValueWriter {
  static writers = /* @__PURE__ */ new Map();
  static write(field, val) {
    if (val === null)
      return val;
    if (field.type == "point" || field.type == "lineString" || field.type == "circle" || field.type === "polygon") {
      return getMapFieldWriter(field)(import_lodash.default.isString(val) ? JSON.parse(val) : val);
    }
    const fieldType = field.typeToString();
    const writer = FieldValueWriter.writers[fieldType];
    if (writer) {
      val = writer(val);
    }
    return val;
  }
  static toDumpedValue(field, val) {
    if (val === null)
      return val;
    if (field.type == "point" || field.type == "lineString" || field.type == "circle" || field.type === "polygon") {
      const mockObj = {
        getDataValue: () => val
      };
      const newValue = field.options.get.call(mockObj);
      return newValue;
    }
    return val;
  }
  static registerWriter(types, writer) {
    for (const type of import_lodash.default.castArray(types)) {
      FieldValueWriter.writers[type] = writer;
    }
  }
}
FieldValueWriter.registerWriter([import_database.DataTypes.JSON.toString(), import_database.DataTypes.JSONB.toString()], (val) => {
  try {
    return import_lodash.default.isString(val) ? JSON.parse(val) : val;
  } catch (err) {
    if (err instanceof SyntaxError && err.message.includes("Unexpected")) {
      return val;
    }
    throw err;
  }
});
FieldValueWriter.registerWriter(import_database.DataTypes.BOOLEAN.toString(), (val) => Boolean(val));
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  FieldValueWriter
});
