import { AppMigrator, AppMigratorOptions } from './app-migrator';
import { Application } from '@nocobase/server';
export declare class Restorer extends AppMigrator {
    direction: "restore";
    backUpFilePath: string;
    decompressed: boolean;
    importedCollections: string[];
    constructor(app: Application, options: AppMigratorOptions & {
        backUpFilePath?: string;
    });
    setBackUpFilePath(backUpFilePath: any): void;
    parseBackupFile(): Promise<any>;
    restore(options: {
        selectedOptionalGroupNames: string[];
        selectedUserCollections: string[];
    }): Promise<void>;
    getImportPlugins(): Promise<any[]>;
    getImportCustomCollections(): Promise<any[]>;
    getImportCollectionTitle(collectionName: any): Promise<any>;
    getImportCollections(): Promise<string[]>;
    getImportCollectionData(collectionName: any): Promise<any[]>;
    getImportCollectionMeta(collectionName: any): Promise<any>;
    getImportMeta(): Promise<any>;
    importCollections(options: {
        ignore?: string | string[];
        selectedOptionalGroupNames: string[];
        selectedUserCollections: string[];
    }): Promise<void>;
    decompressBackup(backupFilePath: string): Promise<void>;
    importCollection(options: {
        name: string;
        insert?: boolean;
        clear?: boolean;
        rowCondition?: (row: any) => boolean;
    }): Promise<any>;
    importDb(): Promise<void>;
}
