var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var server_exports = {};
__export(server_exports, {
  default: () => Duplicator
});
module.exports = __toCommonJS(server_exports);
var import_server = require("@nocobase/server");
var import_dump_command = __toESM(require("./commands/dump-command"));
var import_restore_command = __toESM(require("./commands/restore-command"));
var import_utils = require("@nocobase/utils");
var os = __toESM(require("os"));
var import_dump_action = __toESM(require("./actions/dump-action"));
var import_dumpable_collections_action = __toESM(require("./actions/dumpable-collections-action"));
var import_get_dict_action = __toESM(require("./actions/get-dict-action"));
var import_restore_action = require("./actions/restore-action");
var import_zh_CN = __toESM(require("./locale/zh-CN"));
class Duplicator extends import_server.Plugin {
  beforeLoad() {
    this.app.i18n.addResources("zh-CN", "duplicator", import_zh_CN.default);
    (0, import_dump_command.default)(this.app);
    (0, import_restore_command.default)(this.app);
  }
  async load() {
    this.app.resourcer.define({
      name: "duplicator",
      middleware: async (ctx, next) => {
        if (ctx.action.actionName !== "upload") {
          return next();
        }
        const storage = import_utils.koaMulter.diskStorage({
          destination: os.tmpdir(),
          // 获取临时目录
          filename: function(req, file, cb) {
            const randomName = Date.now().toString() + Math.random().toString().slice(2);
            cb(null, randomName);
          }
        });
        const upload = (0, import_utils.koaMulter)({ storage }).single("file");
        return upload(ctx, next);
      },
      actions: {
        restore: import_restore_action.restoreAction,
        upload: import_restore_action.getPackageContent,
        dump: import_dump_action.default,
        dumpableCollections: import_dumpable_collections_action.default,
        getDict: import_get_dict_action.default
      }
    });
    this.app.acl.allow("duplicator", "getDict");
  }
}
